Subject: Re: A question about changing remote repo name

From: David Aguilar <[email-masked]>
Date: Tue, 5 Jan 2010 13:15:23 -0800

Hi,

On Tue, Jan 05, 2010 at 12:30:03PM +0800, Dongas wrote:
> 2010/1/5 Russell Steicke <[email-masked]>:
> > On Mon, Jan 4, 2010 at 2:45 PM, Dongas <[email-masked]> wrote:
> 
> Thanks a lot, Russell.
> I followed you instruction but it seemed it needs more changes.
> 
> Execute your steps....
> Becomes:
> root@ubuntu:/work/git-repo/free_monkey# tree -a

Just a note: I would recommend against being root.
You cloned the repo so you should own it.

More below...

> root@ubuntu:/work/git-repo/free_monkey# cat .git/config
> [core]
> 	repositoryformatversion = 0
> 	filemode = true
> 	bare = false
> 	logallrefupdates = true
> [remote "karmic"]
> 	url = [email-masked]:free_monkey.git
> 	fetch = +refs/heads/*:refs/remotes/karmic/*
> [branch "master"]
> 	remote = karmic
> 	merge = refs/heads/master
> 
> But the result was:
> root@ubuntu:/work/git-repo/free_monkey# git branch -a
> * master
>   karmic/HEAD
>   origin/master
> The 'origin/master' was still not changed.

A safter alternative would be to leave the "origin" lines in
place as a duplicate of karmic:

[remote "karmic"]
	url = [email-masked]:free_monkey.git
	fetch = +refs/heads/*:refs/karmic/origin/*

[remote "origin"]
	url = [email-masked]:free_monkey.git
	fetch = +refs/heads/*:refs/remotes/origin/*

At that point you will have two remotes, "karmic" and "origin".
"git fetch karmic" to get the latest branches.

Finally, "git remote rm origin" to remove all references to it.

> I did a few more steps:
> root@ubuntu:/work/git-repo/free_monkey# grep -wrin 'origin' .
> ./.git/packed-refs:2:abfae429bb4081043e84681e5ee94102085f87e0
> refs/remotes/origin/master
> ./.git/refs/remotes/karmic/HEAD:1:ref: refs/remotes/origin/master
> 
> Change 'origin' to 'karmic' in above files.

You can skip this step by using "git remote rm" as described
above.

> The steps are a little complicated.
> Do you know if there's a way to rename the remote on server side?
> If there is, then everyone could just clone the project with a new
> remote name rather than the defaul 'origin'.

Unfortunately, no.  "origin" is actually a local thing.
Your local git client gives it that name.  As you can see, the
remote does not care whether we call it "origin" or "karmic".

There were some patches flying around on the ML some time ago
that allowed you to change the default "origin" name on the
client side at "git clone" time (or maybe patches never
materialized and it was purely discussion).

That was a while ago (probably over a year ago) and this wasn't
anybody's itch to scratch in the meantime so nothing every
materialized.  It think this is only the 2nd time this has come
up in that whole time.  Sorry, I wasn't able to find the thread.

Here's a nice middle ground --

instead of naming your branch "master" you can call your default
branch "karmic".

To make it the default for "git clone" then you'll need to push
your local master branch and call it "karmic" over there:

	git push origin master:karmic

Then, go to that server and change the repo's HEAD entry so that
it points to karmic instead of master.

	ssh admin@gitbox
	cd /path/to/repo.git
	vi HEAD

>>From then on, everyone who clones the repo will have a "karmic"
branch by default instead of the master branch.

To get that branch on repos that were cloned before the change:

	git fetch origin
	git checkout -b karmic origin/karmic

With this setup you might even want to remove the "master"
branch altogether since it might be confusing to have both:

Once:
	git push origin :master

In everyone's repo:
	git remote prune origin

You will need to make sure everyone has either:
	a) cloned from the new master-less repo
	b) run the "checkout -b" and "remote prune" commands

Otherwise someone'll likely "git push" the master branch back
into existence.

-- 
		David